#define _CASOED_ 

#include "casoed.h"
#include "main.h"
#include "cpu.h"



int casoed(unsigned char c)
{
	xPC++;
	c=memoria[xPC];
	nx=(c & 192)>>6;  ny=(c & 56)>>3;  nz=(c & 7); np=(c & 48)>>4; nq=(c&8)>>3;
	//printf(" ed %d ",c);
	switch(c)
		{
		 case 0xA0:
			if(tipePrint==1) 	sprintf(cnemo,"LDI");
			memoria[de.w]=memoria[hl.w];
			de.w++;	hl.w++;		bc.w--;
			regF1.PF=bc.w-1;
			return(1);
		 break;
		 case 0xA1:
			if(tipePrint==1) 	sprintf(cnemo,"CPI");
			alu=af.b.h;
			alu-=memoria[hl.w]; 
			setF();
			hl.w++;
			regF1.PF=bc.w-1;
			return(1);
		 break;
		 case 0xA2:
			if(tipePrint==1) 	sprintf(cnemo,"INI...");
		 break;
		 case 0xA3:
			if(tipePrint==1) 	sprintf(cnemo,"OUTI...");
		 break;
		 
		  case 0xA8:
			if(tipePrint==1) 	sprintf(cnemo,"LDD");
			memoria[de.w]=memoria[hl.w];
			de.w--;	hl.w--;		bc.w--;
			regF1.PF=bc.w-1;
			return(1);
		 break;
		 case 0xA9:
			if(tipePrint==1) 	sprintf(cnemo,"CPD");
			bc.w--;
			if(bc.w!=0) regF1.PF=1; else regF1.PF=0;
			if(af.b.h==memoria[hl.w]) regF1.PF=1; else regF1.PF=0;
			hl.w--;
			return(1);
		 break;
		 case 0xAA:
			if(tipePrint==1) 	sprintf(cnemo,"IND...");
		 break;
		 case 0xAB:
			if(tipePrint==1) 	sprintf(cnemo,"OUTD...");
		 break;
		 
		 case 0xB0:
			if(tipePrint==1) 	sprintf(cnemo,"LDIR");
			while(bc.w!=0)
			{
			 memoria[de.w]=memoria[hl.w];
			 de.w++;	hl.w++;		bc.w--;
			}
			return(1);
		 break;
		 case 0xB1:
			if(tipePrint==1) 	sprintf(cnemo,"CPIR");
			while(bc.w!=0 && af.b.h!=memoria[hl.w])
			{
				hl.w++; bc.w--;
			}
			if(bc.w!=0) regF1.PF=1; else regF1.PF=0;
			if(af.b.h==memoria[hl.w]) regF1.PF=1; else regF1.PF=0;
			return(1);
		 break;
		 case 0xB2:
			if(tipePrint==1) 	sprintf(cnemo,"INIR...");
		 break;
		 case 0xB3:
			if(tipePrint==1) 	sprintf(cnemo,"OTIR...");
		 break;
		 
		 case 0xB8:
			if(tipePrint==1) 	sprintf(cnemo,"LDDR");
			while(bc.w!=0 )
			{
				memoria[de.w]=memoria[hl.w];
				de.w--; hl.w--; bc.w--;
				regF1.PF=bc.w-1;
			}
			return(1);
		 break;
		 case 0xB9:
			if(tipePrint==1) 	sprintf(cnemo,"CPDR");
			while(bc.w!=0 && af.b.h!=memoria[hl.w])
			{
				hl.w--; bc.w--;
			}
			if(bc.w!=0) regF1.PF=1; else regF1.PF=0;
			if(af.b.h==memoria[hl.w]) regF1.PF=1; else regF1.PF=0;
						
		 break;
		 case 0xBA:
			if(tipePrint==1) 	sprintf(cnemo,"INDR...");
		 break;
		 case 0xBB:
			if(tipePrint==1) 	sprintf(cnemo,"OTDR...");
		 break;		 
		}	
	
	
	
	switch(nx)
		{
		 case 1:
			switch(nz)
					{
					 case 0:
								if(tipePrint==1)	sprintf(cnemo,"IN %s,(C)",cReg[ny]);
								alu=INz80(bc.w);
								aluToReg(ny);
								setF();
					 break;
					 case 1:
								if(tipePrint==1)	sprintf(cnemo,"OUT (C),%s",cReg[ny]);
								regToAlu(ny);
								OUTz80(bc.w,alu);			
					 break;
					 case 2:
						if(nq==0)
							{
								if(tipePrint==1)	sprintf(cnemo,"SBC HL,%s",qqReg[np]);
								regToAlu32(np);
								hl.w=hl.w-alu32-regF1.CF;
							}
							else
							{
								if(tipePrint==1)	sprintf(cnemo,"ADC HL,%s",qqReg[np]);
								regToAlu32(np);
								hl.w=hl.w+alu32+regF1.CF;
							}								
					 break;
					 case 3:
						if(nq==0)
							{
								if(tipePrint==1)	sprintf(cnemo,"LD (nn),%s",qqReg[np]);
								regToAlu32(np);
								xPC++; alu16.b.l=memoria[xPC];			
								xPC++; alu16.b.h=memoria[xPC];
								memoria[alu16.w]=alu32&255;
								alu16.w++;	memoria[alu16.w]=(alu32>>8)&255;								
							}
							else
							{
								if(tipePrint==1)	sprintf(cnemo,"LD %s,(nn)",qqReg[np]);
								xPC++; alu16.b.l=memoria[xPC];			
								xPC++; alu16.b.h=memoria[xPC];
								alu32=memoria[alu16.w];
								alu16.w++;	alu32<<=8; alu32|=memoria[alu16.w];	
								Alu32ToReg(np);
							}								
					 break;
					 case 4:
						if(tipePrint==1)		sprintf(cnemo,"NEG");
						alu16.w=256; alu16.w-=af.b.h;	af.b.h=alu16.w;
						setF();				
					 break;
					 case 5:
						if(ny==1)
							{
								alu16.b.l=memoria[rSP]; rSP++; 
								alu16.b.h=memoria[rSP]; rSP++; 
								xPC =alu16.w;		
								if(tipePrint==1)	sprintf(cnemo,"RETI ");
								eINT=0;
								return(-2);
							}
							else
							{
								
								alu16.b.l=memoria[rSP]; rSP++; 
								alu16.b.h=memoria[rSP]; rSP++; 
								xPC =alu16.w;
								if(tipePrint==1)	sprintf(cnemo,"RETN ");
								eNMI=0;
								return(-2);
							}		
					 break;
					 case 6:
								if(tipePrint==1)	sprintf(cnemo,"IM %d",ny);
					 break;
					 case 7:
						switch(ny)
							{
							 case 0:
								if(tipePrint==1)	sprintf(cnemo,"LD I,A");
								rI=af.b.h;
							 break;
							 case 1:
								if(tipePrint==1)	sprintf(cnemo,"LD R,A");
								rR=af.b.h;
							 break;
							 case 2:
								if(tipePrint==1)	sprintf(cnemo,"LD A,I");
								af.b.h=rI;
							 break;
							 case 3:
								if(tipePrint==1)	sprintf(cnemo,"LD A,R");
								af.b.h=rR;
							 break;
							 case 4:
								printf("---RRD -ED-%d-%d--\n",nz,np);	return(-1);
							 break;
							 case 5:
								printf("---RLD -ED-%d-%d--\n",nz,np);	return(-1);
							 break;
							 case 6:
								if(tipePrint==1)	sprintf(cnemo,"NOP ed");
							 break;
							 case 7:
								if(tipePrint==1)	sprintf(cnemo,"NOP ed");
							 break;
							}
						
					 break;
					}				
			
		 break;
		 default :
			if(tipePrint==1)	sprintf(cnemo,"NOP ed");	
		 break;
		}	
	return(c);
}
	
