#define _CPU_ 

#include "cpu.h"
#include "main.h"

//CPU

void toAF(void)
{
	if(regF1.CF==1) af.b.l|=128; else af.b.l&=127;
	if(regF1.ZF==1) af.b.l|=64; else af.b.l&=191;
	if(regF1.YF==1) af.b.l|=32; else af.b.l&=223;
	if(regF1.HF==1) af.b.l|=16; else af.b.l&=239;
	if(regF1.XF==1) af.b.l|=8; else af.b.l&=247;
	if(regF1.PF==1) af.b.l|=4; else af.b.l&=251;
	if(regF1.NF==1) af.b.l|=2; else af.b.l&=253;
	if(regF1.CF==1) af.b.l|=1; else af.b.l&=254;	
}

extern void FromAF(void)
{
	if((af.b.l&128)==128) regF1.CF=1; else regF1.CF=0;
	if((af.b.l&64)==64) regF1.ZF=1; else regF1.ZF=0;
	if((af.b.l&32)==32) regF1.YF=1; else regF1.YF=0;
	if((af.b.l&16)==16) regF1.HF=1; else regF1.HF=0;
	if((af.b.l&8)==8) regF1.XF=1; else regF1.XF=0;
	if((af.b.l&4)==4) regF1.PF=1; else regF1.PF=0;
	if((af.b.l&2)==2) regF1.NF=1; else regF1.NF=0;
	if((af.b.l&1)==1) regF1.CF=1; else regF1.CF=0;	
}

void setF(void)
{
  int z,i,p;
	z=alu;
	
	if((alu&128)==128) 	regF1.SF=1; else  regF1.SF=0;		
	if((alu&32)==32) 	regF1.YF=1; else  regF1.YF=0;
	if((alu&16)==16) 	regF1.HF=1; else  regF1.HF=0;
	if((alu&8)==8) 	regF1.XF=1; else  regF1.XF=0;
	p=0;
	for(i=0;i<8;++i)  
		{
		  if(z&0x01){ ++p;}
		  z>>=1;
		}
	if((p&1)==0) 	regF1.PF=1; else  regF1.PF=0;
	//if((alu&128)==128) 	regF1.NF=1; else  regF1.NF=0; //implementar
	if((alu&256)==256) 	regF1.CF=1; else  regF1.CF=0;
	alu=alu&0xFF;
	if(alu==0) 			regF1.ZF=1; else  regF1.ZF=0;
	//printf(" _alu=%d_ p=%d  ",alu,p);
	
}



char getF(unsigned char x)
{
	//printf(" GETF=%d  ",x);
	switch(x)
		{ 
				case 0:
					if(regF1.ZF==0)	 return(1);	//NZ
				break;
				case 1:
					if(regF1.ZF==1) return(1);	//Z
				break ;
				case 3:
					if(regF1.CF==0) return(1);	//NC
				break;
				case 4:
					if(regF1.CF==1) return(1);	//C
				break;
				case 5:
				break;
				case 6:
				break;
				case 7:
					if(regF1.SF==1) return(1);	//C
				break;
			}
	return(-2);
}



unsigned char INz80(unsigned int port)
{
  unsigned char c;
	c=puertos[port];
	return(c);
}

void OUTz80(unsigned int port,unsigned char valor)
{
	puertos[port]=valor;
}




void Alu32ToReg(unsigned char r)
{
			switch(r)
					{
						case 0:
							bc.w=alu32;
						break;
						case 1:
							de.w=alu32;
						break;
						case 2:
							hl.w=alu32;
						break;
						case 3:
							rSP=alu32;
						break;
					}
}

void regToAlu32(unsigned char r)
{			
			switch(r)
					{
						case 0:
							alu32=bc.w;
						break;
						case 1:
							alu32=de.w;
						break;
						case 2:
							alu32=hl.w;
						break;
						case 3:
							alu32=rSP;
						break;
					}
}



void regToAlu(unsigned char r)
{		
		  switch(r)
			{
				case 0:
					alu=bc.b.h;
				break;
				case 1:
					alu=bc.b.l;
				break;
				case 2:
					alu=de.b.h;
				break;
				case 3:
					alu=de.b.l;
				break;
				case 4:
					if( modo!=0 && (ny==5 || ny==6)) alu=HL.b.h; else alu=hl.b.h;   //*****
				break;
				case 5:
					if( modo!=0 && (ny==5 || ny==6)) alu=HL.b.l; else alu=hl.b.l;  //******
				break;
				case 6: 
					alu=memoria[hlm];
				break;
				case 7:
					alu=af.b.h;
				break; 
			}
}

void aluToReg(unsigned char r)
{	
			switch(r)
			{
				case 0:
					bc.b.h=alu;
				break;
				case 1:
					bc.b.l=alu;
				break;
				case 2:
					de.b.h=alu;
				break;
				case 3:
					de.b.l=alu;
				break;
				case 4:
					hl.b.h=alu;
				break;
				case 5:
					hl.b.l=alu;
				break;
				case 6:
					memoria[hlm]=alu;
				break;
				case 7:		
					af.b.h=alu;
				break;
			}
}



char * printReg8_d(unsigned char r)
{
	if(r==6) 
		{
			r+=modo; 
			if(modo==0)
				{
					sprintf(tmpd,"%s",cReg[r]);	
				}
				else
				{
					sprintf(tmpd,"%s&%d)",cReg[r],des);	
				}
		}
		else
		{
			sprintf(tmpd,"%s",cReg[r]);	
		}
		
	return(&tmpd[0]);
}

char * printReg8_s(unsigned char r)
{
	if(r==6) 
		{
			r+=modo; 
			if(modo==0)
				{
					sprintf(tmps,"%s",cReg[r]);	
				}
				else
				{
					sprintf(tmps,"%s&%d)",cReg[r],des);	
				}
		}
		else
		{
			sprintf(tmps,"%s",cReg[r]);	
		}
		
	return(&tmps[0]);
}

