//simulador Z80
// Seta43
  
#define _MAIN_
#include <stdio.h>
#include <time.h>

#include "main.h"

#include "grafi.h"
#include "caso0.h"
#include "caso1.h"
#include "caso2.h"
#include "caso3.h"
#include "casoed.h"
#include "cpu.h"

FILE *pf;
int timeWait=1000;

struct timespec tiempo;
int segun1,segun2;
int nsegun1,nsegun2;

void printVideo(void);

void intNMI(void)
{
	alu16.w=xPC;
	rSP--; memoria[rSP]=alu16.b.h; 
	rSP--; memoria[rSP]=alu16.b.l; 	
	xPC=102;
}

void intINT(void)
{
	alu16.w=xPC;
	rSP--; memoria[rSP]=alu16.b.h; 
	rSP--; memoria[rSP]=alu16.b.l; 	
	xPC=56;
}

int main(int arg, char *argv[])
{
  int z,tecla,e,video;
  unsigned char c;
	 
	if(arg<2)
		{
			printf("ERROR Debes incluir fichero.bin\n");
			printf("Formato  coreZ80 fichero.bin \n");
			printf("\t-t  n  Tiempo entre operaciones\n");
			printf("\t-sp n  Visualizar SP\n");
			printf("\t-me n  Visualizar memoria\n");
			printf("\t-vi n  Salto refresco video\n");
			printf("\t-port n  Visualizar puertos\n");
			printf("\t-p1 Imprimir secuencia terminal\n");
			printf("\t-nmi activar Interrupciones no enmascarables\n");
			printf("\t-int activar Interrupciones enmascarables\n");
			return(-1);
		}
	 pf=fopen(argv[1] ,"rb");
	 if(pf==NULL){ printf("ERROR abriendo fichero  \n"); return(-1);    }
	 fread(memoria,65536,1,pf);
	 fclose(pf);
	 tipeSP=-1; tipeME=-1; tipeME=-1; tipeNMI=0; tipeINT=0; tipePORT=-1;
	 for(z=1;z<arg;z++)
		 {
		  if( !strcmp(argv[z],"-t"))   { timeWait=atoi(argv[z+1]);  printf("time=%03d\n",timeWait ); z++;}
		  if( !strcmp(argv[z],"-sp"))  { tipeSP=atoi(argv[z+1]);    printf("SP=%03d\n",tipeSP);     z++; }
		  if( !strcmp(argv[z],"-me"))  { tipeME=atoi(argv[z+1]);    printf("MEMORIA=%03d\n",tipeME);     z++; }
		  if( !strcmp(argv[z],"-vi"))  { tipeVI=atoi(argv[z+1]);    printf("VIDEO=%03d\n",tipeVI);     z++; }
		  if( !strcmp(argv[z],"-port"))  { tipePORT=atoi(argv[z+1]);    printf("PORT=%03d\n",tipePORT);     z++; }
		  if( !strcmp(argv[z],"-p1"))  { tipePrint=1;}
		  if( !strcmp(argv[z],"-p2"))  { tipePrint=2;}
		  if( !strcmp(argv[z],"-nmi"))  { tipeNMI=1;  printf("NMI=ON\n");}
		  if( !strcmp(argv[z],"-int"))  { tipeINT=1;  printf("INT=ON\n");}
		 }
	
	if (SDL_Init(SDL_INIT_VIDEO) < 0) { printf("No se pudo inicializar SDL: %s\n", SDL_GetError());  exit(1);  }
    screen = SDL_SetVideoMode( 800, 600, 16, SDL_HWSURFACE );
    if( screen == NULL ) { printf( "Error modo grafico: %s\n", SDL_GetError() );  SDL_Quit();  return -1; }
    SDL_WM_SetCaption( "SIMULADOR Z80  seta43", "simuZ80" );
       
    if(-1==leerFuente("font.png","font2.png")) { printf("Error cargando fuente\n"); goto exit;}
		
	setColor(255,255,255);	
		
	Reset();
    pantalla(); 	
    printReg();
    SDL_Flip(screen); 
  
	Fquit=0; video=0;
 	while( Fquit==0 && xPC<65536)
    {
	 tecla=eventosT();	 
	 if(tecla!=-1) 
		{ 
		 //printf("Tecla=%d\n",tecla); 
		 puertos[0]=tecla;
		 if(tecla==SDLK_ESCAPE) Fquit=1;
		}
	 
	 //Interrupcion NMI-----------------------
	 clock_gettime(CLOCK_REALTIME, &tiempo);
	 segun1=tiempo.tv_sec;
	 nsegun1=(tiempo.tv_nsec>>16) & 0xffffff;
	 if(tipeNMI==1 && segun1!=segun2 && eNMI==0)	{ eNMI=1; segun2=segun1; intNMI();	}
	 //Interrupcion INT---------modo 1--------
	 if(tipeINT>0 && eINT==0 && rI==1  &&  ((nsegun1-nsegun2)>1000 || (nsegun1-nsegun2)<-1000) )	{ eINT=1; nsegun2=nsegun1; intINT();	}
	 //---------------------------------------
	 
	 c=memoria[xPC];
	 if(tipePrint==1) printf("%05d %03d ",xPC,c);
	 des=0;
	  switch(c)
		{
		 case 0xDD:	//IX
			modo=2;
			//if(tipePrint==1) printf("*%02X ",c);
			xPC++; c=memoria[xPC];	
			switch(c)
			{
				case 0x09:
				break;
				case 0x19:
				break;
				case 0x21:
				break;
				case 0x22:
				break;
				case 0x23:
				break;
				case 0x29:
				break;
				case 0x2a:
				break;
				case 0x2b:
				break;
				case 0x39:
				break;
				case 0xe1:
				break;
				case 0xe3:
				break;
				case 0xe5:
				break;
				case 0xe9:
				break;
				case 0xf9:
				break;
				default:
					xPC++; des=memoria[xPC];
				break;
			}				
			hlm=IX+des;
			hl.w=IX;
		 break;
		 case 0xFD:	//IY
			modo=3;
			//if(tipePrint==1) printf("*%02X ",c);
			xPC++; c=memoria[xPC];	
			switch(c)
			{
				case 0x09:
				break;
				case 0x19:
				break;
				case 0x21:
				break;
				case 0x22:
				break;
				case 0x23:
				break;
				case 0x29:
				break;
				case 0x2a:
				break;
				case 0x2b:
				break;
				case 0x39:
				break;
				case 0xe1:
				break;
				case 0xe3:
				break;
				case 0xe5:
				break;
				case 0xe9:
				break;
				case 0xf9:
				break;
				default:
					xPC++; des=memoria[xPC];
				break;
			}	
			hlm=IY+des;
			hl.w=IY;
		 break;
		 default:
			modo=0;
			hlm=HL.w;
			hl.w=HL.w;
		 break;
		}	
	 nx=(c & 192)>>6;  ny=(c & 56)>>3;  nz=(c & 7); np=(c & 48)>>4; nq=(c&8)>>3;
	// printf(" c=%d nx=caso%d  ny=%d  nz=%d\n",c,nx,ny,nz);
	 switch(nx)
		 {			 	 
			 case 0: 
				e=caso0(c);	
				if(e==-2) goto saltoJP;		
			 break;				  
			 case 1:
				e=caso1(c);
			 break;	
			 case 2:	
				e=caso2(c);
			 break;		 
			 case 3:
				e=caso3(c);
				if(e==-2) goto saltoJP;
			 break;			 
			 default:
				printf(" ERROR\n");
				e=-1;
			 break; 
		}
		
	 if(e==-1)
		{ 
			if(tipePrint==1)	printf("---ERROR- caso=%d  nz=%d-ny=%d --%s--\n",nx,nz,ny,cnemo);	
			goto fin; 
		}
	 xPC++;

saltoJP:
	 switch(modo)
		{
		 case 0:
			HL.w=hl.w;
		 break;
		 case 2:	//IX
			IX=hl.w;
		 break;
		 case 3:	//IY
			IY=hl.w;
		 break;
		}
	
	 //if(tipePrint==1)	printf("%-15s PC=%04X SP=%04X BC=%04X DE=%04X HL=%04X AF=%04X  S%dZ%dC%dP%d\n",cnemo,rPC,rSP,bc.w,de.w,hl.w,af.w,regF1.SF,regF1.ZF,regF1.CF,regF1.PF);
	 if(tipePrint==1)	printf("%-15s PC=%04X SP=%04X BC=%04X DE=%04X HL=%04X A=%02X IX=%04X IY=%04X S%dZ%dC%dP%d\n",cnemo,rPC,rSP,bc.w,de.w,HL.w,af.b.h,IX,IY,regF1.SF,regF1.ZF,regF1.CF,regF1.PF);
	 
	 if(video<=0)
		 { 
		 printReg();
		 printVideo();
		 pantaGrafica(336,460,ColorDefault);
		 SDL_Flip(screen);
		 video=tipeVI;
		 }
	 video--;
	 
	
	 
	 if(timeWait>0) sleepcp(timeWait);
	 rPC=xPC; 
	}

fin:
		printReg();
		 printVideo();
		 pantaGrafica(336,460,ColorDefault);
		 
	printATs(30,35,"Q para salir");
	printf("Q para salir\n");
	SDL_Flip(screen); 
	while(SDLK_q!=eventosT()) {	 sleepcp(200);	}
exit:
    SDL_Quit();
    return 0;
 }
 


//_________________________________________

void sleepcp(int milliseconds) {  usleep(milliseconds * 1000); }
void Reset(void)
{
	HL.w=af.w=de.w=bc.w=0xffff;
	rPC=rSP=IX=IY=rI=rR=rIFF1=rIFF2=0;	
	af2.w=de2.w=bc2.w=HL2.w=0xffff;
}
//__________________________________________

void printVideo(void)
{
 unsigned int x,m;
	fuentePrint=1;
	m=16384;
	for(x=0;x<16;x++,m++)	{	printATc(x+1,30,memoria[m]);	}
	m=16400;
	for(x=0;x<16;x++,m++)	{	printATc(x+1,31,memoria[m]);	}
}
